#ifndef EVENT_QUEUE_H
#define EVENT_QUEUE_H

#include <TMutex.h>
#include <queue>


class EventQueue
{
public:

	void Push(int value)
	{
		mux.Lock();
		try
		{
			queue.push(value);
		}
		catch (...)
		{
			mux.UnLock();
		}
		mux.UnLock();
	}

	int Pop()
	{
		int result;

		mux.Lock();
		try
		{
			result = queue.front();
			queue.pop();
		}
		catch (...)
		{
			mux.UnLock();
		}
		mux.UnLock();

		return result;
	}

	bool Empty()
	{
		bool result;

		mux.Lock();
		try
		{
			result = queue.empty();
		}
		catch (...)
		{
			mux.UnLock();
		}
		mux.UnLock();

		return result;
	}

private:

	TMutex mux;
	std::queue<int> queue;

};


#endif // EVENT_QUEUE_H
