
#include "guiwindow.h"
#include "eventqueue.h"


ClassImp(GuiWindow)


GuiWindow::GuiWindow() :
	TGMainFrame(gClient->GetRoot(), 10, 10, kMainFrame | kVerticalFrame)
{
	SetLayoutBroken(kTRUE);

	TGTextButton* startbutton = new TGTextButton(this,"Start increment");
	startbutton->SetTextJustify(36);
	startbutton->Resize(92, 24);
	AddFrame(startbutton, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));
	startbutton->MoveResize(8, 8, 92, 24);
	startbutton->Connect("Clicked()", "GuiWindow", this, "StartIncrement()");

	TGTextButton* stopbutton = new TGTextButton(this, "Stop increment");
	stopbutton->SetTextJustify(36);
	stopbutton->Resize(92, 24);
	AddFrame(stopbutton, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));
	stopbutton->MoveResize(8, 40, 92, 24);
	stopbutton->Connect("Clicked()", "GuiWindow", this, "StopIncrement()");

	TGLabel* label = new TGLabel(this, "The thread will increment the number at 10Hz");
	label->SetTextJustify(36);
	AddFrame(label, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));
	label->MoveResize(112, 8, 264, 20);

	TGFont* font = gClient->GetFont("-*-courier-bold-r-*-*-20-*-*-*-*-*-*-*");
	GCValues_t values;
	values.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
	gClient->GetColorByName("#000000", values.fForeground);
	gClient->GetColorByName("#c0c0c0", values.fBackground);
	values.fFillStyle = kFillSolid;
	values.fFont = font->GetFontHandle();
	values.fGraphicsExposures = kFALSE;
	TGGC* ugc = gClient->GetGC(&values, kTRUE);
	outputlabel = new TGLabel(this, "0", ugc->GetGC(), font->GetFontStruct());
	outputlabel->SetTextJustify(36);
	AddFrame(outputlabel, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));
	outputlabel->MoveResize(112, 40, 264, 20);

	MapSubwindows();
	Resize(GetDefaultSize());
	MapWindow();
	Resize(383, 74);
}


GuiWindow::~GuiWindow()
{
	Cleanup();
	gApplication->Terminate(0);
}


void GuiWindow::CloseWindow()
{
	DeleteWindow();
}


extern bool dowork;  // To control the thread.


void GuiWindow::StartIncrement()
{
	dowork = true;
	cout << "start" << endl;
}

void GuiWindow::StopIncrement()
{
	dowork = false;
	cout << "stop" << endl;
}


extern EventQueue eventqueue;


void GuiWindow::UpdateCounter()
{
	while (! eventqueue.Empty())
	{
		// This is where we read off the eventqueue and update the GUI.
		int value = eventqueue.Pop();
		outputlabel->SetText(value);
		outputlabel->Paint();
	}
}
