
#include <TROOT.h>
#include <TApplication.h>
#include <TThread.h>
#include <Riostream.h>

#include "guiwindow.h"
#include "eventqueue.h"


GuiWindow *gui;
EventQueue eventqueue;


bool dowork = false;  // Flag to control if thread is to do work.
bool terminate_thread = false;  // Flag to control termination of the thread.
int counter = 0;


void* IncrementCounter(void* /*ptr*/)
{
	do
	{
		while (dowork)
		{
			counter++;
			gSystem->Sleep(100);

			// Fill the event queue here as we do work.
			eventqueue.Push(counter);

			// Now I have to wake up / signal the main thread that entered
			// into the event loop at app.Run(kTRUE) so that it can call
			// GuiWindow::UpdateCounter() and update the GUI.
			// How would I do that in a ROOT compatable way?
			//Wakeup()
			gui->UpdateCounter();
		}
		gSystem->Sleep(100);
	}
	while (! terminate_thread);
	return 0;
}


///////////////////////////////////////////////////////////////////////////////
// Application entry point:

int main(int argc, char **argv)
{
	TApplication app("App", &argc, argv);
	gui = new GuiWindow();

	// Start thread.
	TThread* thread = new TThread("counterthread", IncrementCounter, NULL);
	thread->Run();

	// kTRUE makes the application return from the event loop on termination.
	app.Run(kTRUE);

	// Cleanup thread.
	terminate_thread = true;
	thread->Join();
	thread->Delete();

	return 0;
}

